org.apache.lucene.queryparser.classic

## Class MultiFieldQueryParser

- java.lang.Object
- - org.apache.lucene.util.QueryBuilder
  - - org.apache.lucene.queryparser.classic.QueryParserBase
    - - org.apache.lucene.queryparser.classic.QueryParser
      - - org.apache.lucene.queryparser.classic.MultiFieldQueryParser

- All Implemented Interfaces:
    QueryParserConstants, CommonQueryParserConfiguration

      public class MultiFieldQueryParser
      extends QueryParser

  A QueryParser which constructs queries to search multiple fields.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.queryparser.classic.QueryParser

      `QueryParser.Operator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<String,Float>` | `boosts`
    `protected String[]` | `fields`

    - ### Fields inherited from class org.apache.lucene.queryparser.classic.QueryParser

      `DEFAULT_SPLIT_ON_WHITESPACE, jj_nt, token, token_source`

    - ### Fields inherited from class org.apache.lucene.queryparser.classic.QueryParserBase

      `AND_OPERATOR, field, OR_OPERATOR`

    - ### Fields inherited from class org.apache.lucene.util.QueryBuilder

      `analyzer, autoGenerateMultiTermSynonymsPhraseQuery, enableGraphQueries, enablePositionIncrements`

    - ### Fields inherited from interface org.apache.lucene.queryparser.classic.QueryParserConstants

      `_ESCAPED_CHAR, _NUM_CHAR, _QUOTED_CHAR, _TERM_CHAR, _TERM_START_CHAR, _WHITESPACE, AND, BAREOPER, Boost, CARAT, COLON, DEFAULT, EOF, FUZZY_SLOP, LPAREN, MINUS, NOT, NUMBER, OR, PLUS, PREFIXTERM, QUOTED, Range, RANGE_GOOP, RANGE_QUOTED, RANGE_TO, RANGEEX_END, RANGEEX_START, RANGEIN_END, RANGEIN_START, REGEXPTERM, RPAREN, STAR, TERM, tokenImage, WILDTERM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiFieldQueryParser(String[] fields, Analyzer analyzer)` Creates a MultiFieldQueryParser.
    `MultiFieldQueryParser(String[] fields, Analyzer analyzer, Map<String,Float> boosts)` Creates a MultiFieldQueryParser.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Query` | `getFieldQuery(String field, String queryText, boolean quoted)`
    `protected Query` | `getFieldQuery(String field, String queryText, int slop)` Base implementation delegates to `QueryParserBase.getFieldQuery(String,String,boolean)`.
    `protected Query` | `getFuzzyQuery(String field, String termStr, float minSimilarity)` Factory method for generating a query (similar to `QueryParserBase.getWildcardQuery(java.lang.String, java.lang.String)`).
    `protected Query` | `getMultiFieldQuery(List<Query> queries)` Creates a multifield query
    `protected Query` | `getPrefixQuery(String field, String termStr)` Factory method for generating a query (similar to `QueryParserBase.getWildcardQuery(java.lang.String, java.lang.String)`).
    `protected Query` | `getRangeQuery(String field, String part1, String part2, boolean startInclusive, boolean endInclusive)`
    `protected Query` | `getRegexpQuery(String field, String termStr)` Factory method for generating a query.
    `protected Query` | `getWildcardQuery(String field, String termStr)` Factory method for generating a query.
    `static Query` | `parse(String[] queries, String[] fields, Analyzer analyzer)` Parses a query which searches on the fields specified.
    `static Query` | `parse(String[] queries, String[] fields, BooleanClause.Occur[] flags, Analyzer analyzer)` Parses a query, searching on the fields specified.
    `static Query` | `parse(String query, String[] fields, BooleanClause.Occur[] flags, Analyzer analyzer)` Parses a query, searching on the fields specified.

    - ### Methods inherited from class org.apache.lucene.queryparser.classic.QueryParser

      `Clause, Conjunction, disable_tracing, enable_tracing, generateParseException, getNextToken, getSplitOnWhitespace, getToken, Modifiers, MultiTerm, Query, ReInit, ReInit, setAutoGeneratePhraseQueries, setSplitOnWhitespace, Term, TopLevelQuery`

    - ### Methods inherited from class org.apache.lucene.queryparser.classic.QueryParserBase

      `addClause, addMultiTermClauses, escape, getAllowLeadingWildcard, getAnalyzeRangeTerms, getAutoGeneratePhraseQueries, getBooleanQuery, getDateResolution, getDefaultOperator, getField, getFuzzyMinSim, getFuzzyPrefixLength, getLocale, getLowercaseExpandedTerms, getMaxDeterminizedStates, getMultiTermRewriteMethod, getPhraseSlop, getTimeZone, init, newBooleanClause, newFieldQuery, newFuzzyQuery, newMatchAllDocsQuery, newPrefixQuery, newRangeQuery, newRegexpQuery, newWildcardQuery, parse, setAllowLeadingWildcard, setAnalyzeRangeTerms, setDateResolution, setDateResolution, setDefaultOperator, setFuzzyMinSim, setFuzzyPrefixLength, setLocale, setLowercaseExpandedTerms, setMaxDeterminizedStates, setMultiTermRewriteMethod, setPhraseSlop, setTimeZone`

    - ### Methods inherited from class org.apache.lucene.util.QueryBuilder

      `add, analyzeBoolean, analyzeGraphBoolean, analyzeGraphPhrase, analyzeMultiBoolean, analyzeMultiPhrase, analyzePhrase, analyzeTerm, createBooleanQuery, createBooleanQuery, createFieldQuery, createFieldQuery, createMinShouldMatchQuery, createPhraseQuery, createPhraseQuery, createSpanQuery, getAnalyzer, getAutoGenerateMultiTermSynonymsPhraseQuery, getEnableGraphQueries, getEnablePositionIncrements, newBooleanQuery, newGraphSynonymQuery, newMultiPhraseQueryBuilder, newSynonymQuery, newTermQuery, setAnalyzer, setAutoGenerateMultiTermSynonymsPhraseQuery, setEnableGraphQueries, setEnablePositionIncrements`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.lucene.queryparser.flexible.standard.CommonQueryParserConfiguration

      `getAnalyzer, getEnablePositionIncrements, setEnablePositionIncrements`

- - ### Field Detail

    - #### fields

          protected String[] fields

    - #### boosts

          protected Map<String,Float> boosts

  - ### Constructor Detail

    - #### MultiFieldQueryParser

          public MultiFieldQueryParser(String[] fields,
                                       Analyzer analyzer,
                                       Map<String,Float> boosts)

      Creates a MultiFieldQueryParser. Allows passing of a map with term to Boost, and the boost to apply to each term.

      It will, when parse(String query) is called, construct a query like this (assuming the query consists of two terms and you specify the two fields `title` and `body`):

      `(title:term1 body:term1) (title:term2 body:term2)`

      When setDefaultOperator(AND_OPERATOR) is set, the result will be:

      `+(title:term1 body:term1) +(title:term2 body:term2)`

      When you pass a boost (title=>5 body=>10) you can get

      `+(title:term1^5.0 body:term1^10.0) +(title:term2^5.0 body:term2^10.0)`

      In other words, all the query's terms must appear, but it doesn't matter in what fields they appear.

    - #### MultiFieldQueryParser

          public MultiFieldQueryParser(String[] fields,
                                       Analyzer analyzer)

      Creates a MultiFieldQueryParser.

      It will, when parse(String query) is called, construct a query like this (assuming the query consists of two terms and you specify the two fields `title` and `body`):

      `(title:term1 body:term1) (title:term2 body:term2)`

      When setDefaultOperator(AND_OPERATOR) is set, the result will be:

      `+(title:term1 body:term1) +(title:term2 body:term2)`

      In other words, all the query's terms must appear, but it doesn't matter in what fields they appear.

  - ### Method Detail

    - #### getFieldQuery

          protected Query getFieldQuery(String field,
                                        String queryText,
                                        int slop)
                                 throws ParseException

      Description copied from class: `QueryParserBase`
      Base implementation delegates to `QueryParserBase.getFieldQuery(String,String,boolean)`. This method may be overridden, for example, to return a SpanNearQuery instead of a PhraseQuery.
      Overrides:
        `getFieldQuery` in class `QueryParserBase`
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getFieldQuery

          protected Query getFieldQuery(String field,
                                        String queryText,
                                        boolean quoted)
                                 throws ParseException

      Overrides:
        `getFieldQuery` in class `QueryParserBase`
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getFuzzyQuery

          protected Query getFuzzyQuery(String field,
                                        String termStr,
                                        float minSimilarity)
                                 throws ParseException

      Description copied from class: `QueryParserBase`
      Factory method for generating a query (similar to `QueryParserBase.getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that has the fuzzy suffix (~) appended.
      Overrides:
        `getFuzzyQuery` in class `QueryParserBase`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token to use for building term for the query
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getPrefixQuery

          protected Query getPrefixQuery(String field,
                                         String termStr)
                                  throws ParseException

      Description copied from class: `QueryParserBase`
      Factory method for generating a query (similar to `QueryParserBase.getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that uses prefix notation; that is, contains a single '*' wildcard character as its last character. Since this is a special case of generic wildcard term, and such a query can be optimized easily, this usually results in a different query object.

      Depending on settings, a prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

      Can be overridden by extending classes, to provide custom handling for wild card queries, which may be necessary due to missing analyzer calls.

      Overrides:
        `getPrefixQuery` in class `QueryParserBase`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token to use for building term for the query (without trailing '*' character!)
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getWildcardQuery

          protected Query getWildcardQuery(String field,
                                           String termStr)
                                    throws ParseException

      Description copied from class: `QueryParserBase`
      Factory method for generating a query. Called when parser parses an input term token that contains one or more wildcard characters (? and *), but is not a prefix term token (one that has just a single * character at the end)

      Depending on settings, prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

      Can be overridden by extending classes, to provide custom handling for wildcard queries, which may be necessary due to missing analyzer calls.

      Overrides:
        `getWildcardQuery` in class `QueryParserBase`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token that contains one or more wild card characters (? or *), but is not simple prefix term
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getRangeQuery

          protected Query getRangeQuery(String field,
                                        String part1,
                                        String part2,
                                        boolean startInclusive,
                                        boolean endInclusive)
                                 throws ParseException

      Overrides:
        `getRangeQuery` in class `QueryParserBase`
      Throws:
        `ParseException`

    - #### getRegexpQuery

          protected Query getRegexpQuery(String field,
                                         String termStr)
                                  throws ParseException

      Description copied from class: `QueryParserBase`
      Factory method for generating a query. Called when parser parses an input term token that contains a regular expression query.

      Depending on settings, pattern term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with regular expression templates.

      Can be overridden by extending classes, to provide custom handling for regular expression queries, which may be necessary due to missing analyzer calls.

      Overrides:
        `getRegexpQuery` in class `QueryParserBase`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token that contains a regular expression
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getMultiFieldQuery

          protected Query getMultiFieldQuery(List<Query> queries)
                                      throws ParseException

      Creates a multifield query
      Throws:
        `ParseException`

    - #### parse

          public static Query parse(String[] queries,
                                    String[] fields,
                                    Analyzer analyzer)
                             throws ParseException

      Parses a query which searches on the fields specified.

      If x fields are specified, this effectively constructs:

           (field1:query1) (field2:query2) (field3:query3)...(fieldx:queryx)

      Parameters:
        `queries` - Queries strings to parse
        `fields` - Fields to search on
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `IllegalArgumentException` - if the length of the queries array differs from the length of the fields array

    - #### parse

          public static Query parse(String query,
                                    String[] fields,
                                    BooleanClause.Occur[] flags,
                                    Analyzer analyzer)
                             throws ParseException

      Parses a query, searching on the fields specified. Use this if you need to specify certain fields as required, and others as prohibited.

      Usage:

           String[] fields = {"filename", "contents", "description"};
           BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
                          BooleanClause.Occur.MUST,
                          BooleanClause.Occur.MUST_NOT};
           MultiFieldQueryParser.parse("query", fields, flags, analyzer);

      The code above would construct a query:

           (filename:query) +(contents:query) -(description:query)

      Parameters:
        `query` - Query string to parse
        `fields` - Fields to search on
        `flags` - Flags describing the fields
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `IllegalArgumentException` - if the length of the fields array differs from the length of the flags array

    - #### parse

          public static Query parse(String[] queries,
                                    String[] fields,
                                    BooleanClause.Occur[] flags,
                                    Analyzer analyzer)
                             throws ParseException

      Parses a query, searching on the fields specified. Use this if you need to specify certain fields as required, and others as prohibited.

      Usage:

           String[] query = {"query1", "query2", "query3"};
           String[] fields = {"filename", "contents", "description"};
           BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
                          BooleanClause.Occur.MUST,
                          BooleanClause.Occur.MUST_NOT};
           MultiFieldQueryParser.parse(query, fields, flags, analyzer);

      The code above would construct a query:

           (filename:query1) +(contents:query2) -(description:query3)

      Parameters:
        `queries` - Queries string to parse
        `fields` - Fields to search on
        `flags` - Flags describing the fields
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `IllegalArgumentException` - if the length of the queries, fields, and flags array differ

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.